# vhsm secrets list

The `vhsm secrets list` command lists all enabled secrets engines on the vHSM server. It also displays key details such as configured TTLs and descriptions.

A TTL value of `"system"` means the system default TTL is in use.

{% hint style="info" %}

### **Deprecation status column**

* All built-in secrets engines have an associated Deprecation Status.
* For custom (non-built-in) secrets engines, this column will display `"n/a"`.
  {% endhint %}

**Usage**

```sh
vhsm secrets list [options]
```

### **Version Columns (`-detailed` flag)**

Using the `-detailed` flag provides additional version details:

| Column              | Description                                                                                                                           |
| ------------------- | ------------------------------------------------------------------------------------------------------------------------------------- |
| **Version**         | Configured plugin version (empty or `"n/a"` means built-in or unversioned).                                                           |
| **Running Version** | The **actual plugin version** currently running.                                                                                      |
| **Running SHA256**  | The SHA256 checksum of the running plugin binary. If different from the catalog, the plugin hasn't been **reloaded** since an update. |

***

### **Examples**

* List all enabled secrets engines

  ```sh
  vhsm secrets list
  ```

  **Output**

  ```
  EditPath          Type         Accessor              Description
  ----          ----         --------              -----------
  cubbyhole/    cubbyhole    cubbyhole_548b4dc5    per-token private secret storage
  secret/       kv           identity_aa00c06d     key/value secret storage
  sys/          system       system_547412e3       system endpoints used for control, policy, and debugging
  ```
* List all enabled secrets engines with detailed output

  ```sh
  vhsm secrets list -detailed
  ```

  **Output**

  ```
  Path           Plugin        Accessor               Default TTL    Max TTL    Force No Cache    Replication    Seal Wrap    External Entropy Access    Options    Description                                                UUID                                  Version    Running Version          Running SHA256    Deprecation Status
  ----           ------        --------               -----------    -------    --------------    -----------    ---------    -----------------------    -------    -----------                                                ----                                  -------    ---------------          --------------    ------------------
  cubbyhole/     cubbyhole     cubbyhole_b16d1bc0     n/a            n/a        false             local          false        false                      map[]      per-token private secret storage                           8c64d56b-9d46-d667-1155-a8c1a83a5d01  n/a        v1.12.0+builtin.vault    n/a               n/a
  identity/      identity      identity_3d67c936      system         system     false             replicated     false        false                      map[]      identity store                                             5aa1e59c-33b5-9dec-05d6-c80c9a800557  n/a        v1.12.0+builtin.vault    n/a               n/a
  postgresql/    postgresql    postgresql_f0a54308    system         system     false             replicated     false        false                      map[]      n/a                                                        8cdc1d2d-0713-eaa6-17e3-49790a60650b  n/a        v1.12.0+builtin.vault    n/a               deprecated
  sys/           system        system_c86bd362        n/a            n/a        false             replicated     true         false                      map[]      system endpoints used for control, policy and debugging    e3193999-0875-d38d-3458-21d9f2762c80  n/a        v1.12.0+builtin.vault    n/a               n/a
  ```

### **Available Options**

#### **Output Options**

| Option             | Description                                                                                                                                 |
| ------------------ | ------------------------------------------------------------------------------------------------------------------------------------------- |
| `-format=<string>` | Specifies the output format: **"table"** (default), **"json"**, or **"yaml"**. Can also be set via the `VAULT_FORMAT` environment variable. |

#### **Command Options**

| Option      | Description                                                                                                                        |
| ----------- | ---------------------------------------------------------------------------------------------------------------------------------- |
| `-detailed` | Displays **detailed information** about each secrets engine, including **replication status, configuration, and version details**. |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.enclaive.cloud/virtual-hsm/cli/secret-management/vhsm-secrets/vhsm-secrets-list.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
